#include <stdio.h>
#include "mpi.h"

int main(int argc, char *argv[]) {
	int my_rank, p, i, res, finres, start, end, num, N, source, target, tag1 = 5, tag2 = 6;
	MPI_Status status;

	MPI_Init(&argc, &argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);
	MPI_Comm_size(MPI_COMM_WORLD, &p);

	if (my_rank == 0)  {
		printf("Enter last number: ");
		scanf("%d", &N);
		for (target = 1; target < p; target++) {
			MPI_Send(&N, 1, MPI_INT, target, tag1, MPI_COMM_WORLD);
		}
 	} else {
		MPI_Recv(&N, 1, MPI_INT, 0, tag1, MPI_COMM_WORLD, &status);
	}

	res   = 0;
	num   = N / p;
	start = (my_rank * num) + 1;
	end   = start + num;

	for (i = start; i < end; i++) {
		res += (i * i);
	}

	if (my_rank != 0)  {
		MPI_Send(&res, 1, MPI_INT, 0, tag2, MPI_COMM_WORLD);
	} else {
		finres = res;

		printf("\nResult of process %d: %d\n", my_rank, res);

		for (source = 1; source < p; source++)  {
			MPI_Recv(&res, 1, MPI_INT, source, tag2, MPI_COMM_WORLD, &status);
			finres += res;
			printf("\nResult of process %d: %d\n", source, res);
		}
		printf("\n\n\nFinal result: %d\n", finres);
	}

	MPI_Finalize();

	return(0);
}

